package gameplay;

public class AI { // Artificial Inteligence do Paraguai
    public enum Nivel {easy, medium, hard, expert, missile};
    
    private Enemy host;
    public Nivel nivel;

    public int left = 0, right = 1, up = 2, down = 3;
    public boolean[] command = new boolean[4];

    public AI(Enemy enemy, Nivel nivel) {
        host = enemy;
        this.nivel = nivel;
    }

    public void Play() {
        switch(nivel) {
            case easy:
                easyControl();
                break;
            case medium:
                mediumControl();
                break;
            case hard:
                hardControl();
                break;
            case expert:
                expertControl();
                break;
            case missile:
                missileControl();
                break;
        }
    }

    private void easyControl() {
        if(Enemy.getAim().y < host.y + 2*host.height && Enemy.getAim().y + Enemy.getAim().height > host.y - host.height && Enemy.getAim().x < host.x)
            host.Shoot();

        command[left] = true;
        command[right] = false;
        command[up] = false;
        command[down] = false;
    }

    private void mediumControl() {
        if(Enemy.getAim().x < host.x)
            host.Shoot();

        command[left] = true;
        command[right] = false;
        command[up] = false;
        command[down] = false;

        if(Math.abs(Enemy.getAim().y - host.y) > 100.0) {
            if(Enemy.getAim().y > host.y)
                command[down] = true;
            else
                command[up] = true;
        }
    }

    private void hardControl() {
        if(Enemy.getAim().x < host.x)
            host.Shoot();

        command[left] = false;
        command[right] = false;
        command[up] = false;
        command[down] = false;

        if(Math.abs(Enemy.getAim().y - host.y) > 100.0) {
            if(Enemy.getAim().y > host.y)
                command[down] = true;
            else
                command[up] = true;
        }

        if(host.x - Enemy.getAim().x < 150.0)
            command[right] = true;
        else if(host.x - Enemy.getAim().x > 300.0)
            command[left] = true;
    }

    private void expertControl() {
        hardControl();

        if(host.isInTheSameLine(Enemy.getAim())) {
            if(host.x < Enemy.getAim().x)
                command[up] = true;
            else
                command[down] = true;
        }
    }

    private void missileControl() {
        command[left] = true;
        command[right] = false;
        command[up] = false;
        command[down] = false;
    }

    public static Nivel getNivelOf(int nivel) {
        if(nivel == 0)
            return Nivel.easy;
        else if(nivel == 1)
            return Nivel.medium;
        else if(nivel == 2)
            return Nivel.hard;
        else if(nivel == 3)
            return Nivel.expert;

        return Nivel.missile;
    }
}
