package gameplay;

import java.util.ArrayList;
import JPlay.*;

public class Background {
    public Window        app;
    public GameImage     image, deep;
    public double        createrate, counter;
    public static double velocity;

    public ArrayList<Particle> particle_list, deep_list;

    public Background(Window app, String img, String deep, double createrate, double velocity) {
        this.app = app;

        this.image = new GameImage(img);
        this.deep = new GameImage(deep);

        this.createrate = createrate;

        Background.velocity = velocity;

        this.particle_list = new ArrayList();
        this.deep_list = new ArrayList();
    }

    public void Action(double elapsed) {
        Create(elapsed);
        Move(elapsed);
        destroyParticles();
    }

    public void Create(double elapsed) {
        counter += elapsed;

        if(counter >= 1.0/createrate) {
            if(Math.round(Math.random()*2.0) == 2)
                deep_list.add(new Particle(deep, app.getWidth() + Math.random()*30, Math.random()*app.getHeight()));
            particle_list.add(new Particle(image, app.getWidth(), Math.random()*app.getHeight()));

            counter = 0.0;
        }
    }

    public void Move(double elapsed) {
        for(int i = 0; i < particle_list.size(); i++)
            particle_list.get(i).x -= velocity*elapsed;

        for(int i = 0; i < deep_list.size(); i++)
            deep_list.get(i).x -= (velocity/5.0)*elapsed;
    }

    public void destroyParticles() {
        for(int i = 0; i < particle_list.size(); i++) {
            if(particle_list.get(i).x + image.width < 0) {
                particle_list.remove(i);

                i--;
            }
        }

        for(int i = 0; i < deep_list.size(); i++) {
            if(deep_list.get(i).x + deep.width < 0) {
                deep_list.remove(i);

                i--;
            }
        }
    }

    public void Draw() {
        for(int i = 0; i < particle_list.size(); i++)
            particle_list.get(i).Draw();

        for(int i = 0; i < deep_list.size(); i++)
            deep_list.get(i).Draw();
    }
}