package gameplay;

import JPlay.*;

public class Enemy extends Spaceship {
    private static Player aim;
    public AI ai;
    public double limitx, limity;
    public String image;
    public boolean noFire;

    public Enemy(double x, double y, String img, int frames, AI.Nivel nivel, int ID) { // The constructor
        super(img, frames, ID);
        image = img;

        ai = new AI(this, nivel);

        this.x = x;
        this.y = y;

        this.noFire = false;
    }

    @Override
    protected void Control(double elapsed) { // Overriden method which handles the spaceship
        firetime += (long)(elapsed*1000.0);

        ai.Play();

        if(ai.command[ai.left])
            velocity_x -= agility*elapsed;
        else if(ai.command[ai.right])
            velocity_x += agility*elapsed;
        else {
            if(velocity_x > 0.0) {
                velocity_x -= (agility*elapsed)/2.0;
                if(velocity_x < 0.0) velocity_x = 0.0;
            } else if(velocity_x < 0.0) {
                velocity_x += (agility*elapsed)/2.0;
                if(velocity_x > 0.0) velocity_x = 0.0;
            }
        }

        if(ai.command[ai.up])
            velocity_y -= (agility*elapsed);
        else if(ai.command[ai.down])
            velocity_y += (agility*elapsed);
        else {
            if(velocity_y > 0.0) {
                velocity_y -= (agility*elapsed)/2.0;
                if(velocity_y < 0.0) velocity_y = 0.0;
            } else if(velocity_y < 0.0) {
                velocity_y += (agility*elapsed)/2.0;
                if(velocity_y > 0.0) velocity_y = 0.0;
            }
        }

        fixPosition();

        if(velocity_x > maxspeed)
            velocity_x = maxspeed;
        if(velocity_x < -maxspeed)
            velocity_x = -maxspeed;
        if(velocity_y > maxspeed)
            velocity_y = maxspeed;
        if(velocity_y < -maxspeed)
            velocity_y = -maxspeed;

        noFire = false;
    }

    private void fixPosition() {
        if(y < 0.0) {
            y = 0.0;

            velocity_y = -velocity_y/2.0;
        } else if(y > limity - height) {
            y = limity - height;

            velocity_y = -velocity_y/2.0;
        }
    }

    public void takeCare(Spaceship other, double elapsed) { // Método que faz com que a nave "tome cuidado" para não colidir com outras
        if(isInTheSameLine(other) && other.alive) {
            if(x > other.x && x < other.x + other.width + 40.0)
                velocity_x += agility*elapsed;
            else if(x + width < other.x && x + width > other.x - 40.0 )
                velocity_x -= agility*elapsed;

            if(other.x < x)
                noFire = true;
        }

        if(isInTheSameColumn(other) && other.alive) {
            if(y > other.y && y < other.y + other.height + 40.0)
                velocity_y += agility*elapsed;
            else if(y + height < other.y && y + height > other.y - 40.0)
                velocity_y -= agility*elapsed;
        }
    }

    public boolean isInTheSameLine(Sprite other) {
        if(y + height >= other.y && y < other.y + other.height)
            return true;

        return false;
    }

    private boolean isInTheSameColumn(Sprite other) {
        if(x + width >= other.x && x < other.x + other.width)
            return true;

        return false;
    }

    public void Shoot() { // Atira
        if(!noFire) {
            double inix = x - 20.0;
            double iniy = y + this.height/2.0;
            double hip = Math.sqrt(Math.pow(inix - (aim.x + aim.width/2.0), 2.0) +
                                   Math.pow(iniy - (aim.y + aim.height/2.0), 2.0));
            double velx = ((aim.x + aim.width/2.0) - inix)/hip * bulletveloc;
            double vely = ((aim.y + aim.height/2.0) - iniy)/hip * bulletveloc;

            if(firetime >= (int)firerate) {
                Spaceship.bulletmanager.Create(this.x - 20.0, this.y + this.height/2.0, velx < 0.0 ? velx : 0.0, vely, bulletdamage, bulletimg, this.ID);

                firetime = 0;

                // new Sound("data/sounds/shot1.wav").play();
            }
        }
    }

    public static void setAim(Player aim) {
        Enemy.aim = aim;
    }

    public static Player getAim() {
        return Enemy.aim;
    }
}
