/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gameplay;

import JPlay.*;
import java.awt.event.KeyEvent;

public class Player extends Spaceship {
    public enum Gun {normal, trippleshot};

    private Keyboard    input;
    private Mouse       mouse;
    private double      limitx, limity;
    public double       money;
    public boolean      firing, leftbuttonprestate;
    public Gun          guntype;

    public Player(double x, double y, String img, int frames, Window app) { // The guy
        super(img, frames, 0);

        this.input = app.getKeyboard();
        this.mouse = app.getMouse();

        limitx = app.getWidth();
        limity = app.getHeight();

        this.x = x;
        this.y = y;

        this.firing = false;

        this.guntype = Gun.normal;
    }

    @Override
    protected void Control(double elapsed) { // Overriden method which handles the spaceship
        if(input.keyDown(Keyboard.LEFT_KEY) || input.keyDown(KeyEvent.VK_A))
            velocity_x -= agility*elapsed;
        else if(input.keyDown(Keyboard.RIGHT_KEY) || input.keyDown(KeyEvent.VK_D))
            velocity_x += agility*elapsed;
        else {
            if(velocity_x > 0.0) {
                velocity_x -= (agility*elapsed)/2.0;
                if(velocity_x < 0.0) velocity_x = 0.0;
            } else if(velocity_x < 0.0) {
                velocity_x += (agility*elapsed)/2.0;
                if(velocity_x > 0.0) velocity_x = 0.0;
            }
        }

        if(input.keyDown(Keyboard.UP_KEY) || input.keyDown(KeyEvent.VK_W))
            velocity_y -= (agility*elapsed);
        else if(input.keyDown(Keyboard.DOWN_KEY) || input.keyDown(KeyEvent.VK_S))
            velocity_y += (agility*elapsed);
        else {
            if(velocity_y > 0.0) {
                velocity_y -= (agility*elapsed)/2.0;
                if(velocity_y < 0.0) velocity_y = 0.0;
            } else if(velocity_y < 0.0) {
                velocity_y += (agility*elapsed)/2.0;
                if(velocity_y > 0.0) velocity_y = 0.0;
            }
        }

        fixPosition();

        leftbuttonprestate = mouse.isLeftButtonPressed();
        if(leftbuttonprestate && !firing)
            firing = true;
        else if(leftbuttonprestate && firing)
            firing = false;

        firetime += elapsed*1000.0;
        if(firing && firetime >= (int)firerate) {
            Shoot();

            firetime = 0;
        }

        if(velocity_x > maxspeed)
            velocity_x = maxspeed;
        if(velocity_x < -maxspeed)
            velocity_x = -maxspeed;
        if(velocity_y > maxspeed)
            velocity_y = maxspeed;
        if(velocity_y < -maxspeed)
            velocity_y = -maxspeed;
    }

    private void fixPosition() {
        if(x < 0.0) {
            x = 0.0;

            velocity_x = -velocity_x/2.0;
        } else if(x > limitx - width) {
            x = limitx - width;

            velocity_x = -velocity_x/2.0;
        }

        if(y < 0.0) {
            y = 0.0;

            velocity_y = -velocity_y/2.0;
        } else if(y > limity - height) {
            y = limity - height;

            velocity_y = -velocity_y/2.0;
        }
    }

    private void Shoot() { // Atira
        double inix = x + width + 10.0;
        double iniy = y + this.height/2.0;
        double hip = Math.sqrt(Math.pow(inix - (double)mouse.getPosition().x, 2.0) +  //  Calcula a hipotenusa
                               Math.pow(iniy - (double)mouse.getPosition().y, 2.0));  //   **
        double velx = ((double)mouse.getPosition().x - inix)/hip * bulletveloc; // Cosseno do angulo entre o player e o mouse em relação ao eixo X
        double vely = ((double)mouse.getPosition().y - iniy)/hip * bulletveloc; //  Seno   **   **     **  *  **    * *  **    *   **    *   **  *

        Spaceship.bulletmanager.Create(this.x + this.width + 10, this.y + this.height/2.0, velx > 0.0 ? velx : 0.0, velx > 0.0 ? vely : vely > 0.0 ? bulletveloc : -bulletveloc, bulletdamage, bulletimg, 0);

        if(guntype == Gun.trippleshot) { // Verifica se o tripleshot está ativado
            velx = Math.cos(Math.acos(((double)mouse.getPosition().x - inix)/hip) + 0.1) * bulletveloc;
            vely = Math.sin(Math.asin(((double)mouse.getPosition().y - iniy)/hip) + 0.1) * bulletveloc;
            Spaceship.bulletmanager.Create(this.x + this.width + 10, this.y + this.height/2.0, velx > 0.0 ? velx : 0.0, velx > 0.0 ? vely : vely > 0.0 ? bulletveloc : -bulletveloc, bulletdamage, bulletimg, 0);

            velx = Math.cos(Math.acos(((double)mouse.getPosition().x - inix)/hip) - 0.1) * bulletveloc;
            vely = Math.sin(Math.asin(((double)mouse.getPosition().y - iniy)/hip) - 0.1) * bulletveloc;
            Spaceship.bulletmanager.Create(this.x + this.width + 10, this.y + this.height/2.0, velx > 0.0 ? velx : 0.0, velx > 0.0 ? vely : vely > 0.0 ? bulletveloc : -bulletveloc, bulletdamage, bulletimg, 0);
        }
        // new Sound("data/sounds/shot2.wav").play();
    }

    public void Collision(boolean collided) { // Recebe true em caso de colisão com outra nave
        if(collided) {
            alive = false;
            
            casco = 0;
        }
    }
}
