package gameplay.hud;

import JPlay.*;
import gameplay.Player;

public class HUD {
    private Window app;
    private Player player;
    private Panel healthpanel, moneypanel;

    public HUD(Window app, Player player) {
        this.app = app;

        this.player = player;

        healthpanel = new Panel(app, "data/gameplay/healthpanel.png", app.getWidth() - 220, app.getHeight() - 60);
        moneypanel = new Panel(app, "data/gameplay/moneypanel.png", app.getWidth() - 110, app.getHeight() - 60);
    }

    public void Refresh() {
        healthpanel.setText("" + (int)player.casco);
        moneypanel.setText("P$: " + (int)player.money);
    }

    public void Draw() {
        healthpanel.Draw();
        moneypanel.Draw();
    }
}
