package gameplay.hud;

import java.awt.Color;
import java.awt.Font;
import JPlay.*;

public class Panel {
    private Window app;
    private GameImage background;
    private Font font;
    private Color color;
    private String text;

    public double x, y;

    public Panel(Window app, String bgimg, double x, double y) {
        this(app, bgimg, x, y, new Font("Arial", Font.TRUETYPE_FONT, 14), Color.BLACK);
    }

    public Panel(Window app, String bgimg, double x, double y, Font font, Color color) {
        this.app = app;
        this.background = new GameImage(bgimg);
        this.font = font;
        this.color = color;
        this.x = x;
        this.y = y;
    }

    public void setText(String text) {
        this.text = text;
    }

    public void Draw() {
        background.setPosition(x, y);

        background.draw();
        app.drawText(text, (int)(x+15.0), (int)(y + (background.height/5.0)*4.0), color, font);
    }
}
