package menupack;

import JPlay.Window;
import JPlay.Keyboard;
import JPlay.Mouse;
import JPlay.GameImage;
import java.util.Vector;
import soundpack.*;

public class Menu {
    private Window    app;
    private Music     music;

    private GameImage background;
    Vector<Button> buttons = new Vector<Button>(); // Lista de botões

    private Keyboard  keyboard;
    private Mouse     mouse;

    private int opc; // Representa a opção escolhida

    public Menu(Window _app) {
        app = _app;

        keyboard = _app.getKeyboard();
        mouse = _app.getMouse();

        music = new Music("data/music/music2.wav", 60.0, 0);
    }

    public int Run() { // Inicia o menu
        opc = -1;

        music.Start();

        Loop();

        music.Stop();

        return opc;
    }

    public boolean AddButton(String img, int x, int y) { // Adiciona um botão ao menu
        return buttons.add(new Button(img, x, y, mouse));
    }

    public void setBackground(String img) { // Muda o fundo do menu
        background = new GameImage(img);
    }

    private void Loop() { // Loop lógico do menu
        while(opc < 0) {
            if(mouse.isLeftButtonPressed()) { // Verifica se o botão esquerdo do mouse foi pressionado
                for(int i = 0; i < buttons.size(); i++) // Verifica se o mouse estava sobre algum botão
                    if(buttons.get(i).isMouseOn())
                        opc = i;
            }

            if(keyboard.keyDown(Keyboard.ESCAPE_KEY))
                opc = buttons.size() - 1;

            Draw();
        }
    }

    private void Draw() { // Desenha o menu
        background.draw();

        for(int i = 0; i < buttons.size(); i++) { // Desenha cada botão da lista
            buttons.get(i).draw();
        }

        app.display();
    }
}
