package pollux;

import JPlay.*;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import menupack.Menu;
import ranking.*;
import java.io.File;
import java.util.Scanner;

public class Game {
    private Window app; // Janela do jogo
    private Menu menu;

    public Game(int winWidth, int winHeight) {
        app = new Window(winWidth, winHeight);
        app.getKeyboard().setBehavior(Keyboard.SPACE_KEY, Keyboard.DETECT_EVERY_PRESS);

        ConstructMenu();
    }

    public void Run() throws FileNotFoundException, IOException { // Quando chamado inicia o jogo
        Loop();

        app.exit();
    }

    public void Loop() throws FileNotFoundException, IOException { // Loop primário do jogo, gerencia escolhas de menu
        int index = 0;

        while(index != 2) {
            index = menu.Run();

            switch(index) { // Verifica qual opção foi escolhida
                case 0:
                    RunGameplay();
                    break;
                case 1:
                    RunRanking();
                    break;
            }
        }
    }

    private void RunGameplay() throws FileNotFoundException, IOException {
        gameplay.Space space = new gameplay.Space(app);

        space.Run();
    }

    private void RunRanking() {
        Ranking rank = new Ranking(app);

        rank.Run();
    }

    private void RunCredits() {

    }

    private void ConstructMenu() { // Configura o menu
        try {
            menu = new Menu(app);

            File file = new File("data/menu/config.ini");
            Scanner reader = new Scanner(file);

            menu.setBackground(reader.next());

            int max = reader.nextInt();
            for(int i = 0; i < max; i++)
                menu.AddButton(reader.next(), reader.nextInt(), reader.nextInt());
        } catch (FileNotFoundException ex) {
            Logger.getLogger(Game.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
