package ranking;

import java.util.Vector;
import java.util.Scanner;
import java.io.*;
import java.util.logging.Level;
import java.util.logging.Logger;

public class RankHandle {
    private Vector<Position> list;

    public RankHandle() {
        list = new Vector<Position>();
    }

    public void Add(Position record) { // Adiciona um novo record
        if(!addIfAlreadyInRanking(record)) {
            if(list.size() > 0)
                addSorted(record);
            else
                list.add(record);
        }
    }

    private boolean addIfAlreadyInRanking(Position record) { // Adiciona no ranking se o nome já existe
        if(list.isEmpty())
            return false;
        else {
            int pos = getPositionInRanking(record);
            if(pos >= 0) {
                if(list.get(pos).points < record.points) {
                    list.get(pos).name = record.name;
                    list.get(pos).points = record.points;
                }

                return true;
            }
        }

        return false;
    }

    private void addSorted(Position record) { // Adiciona no ranking na posição certa
        if(record.points > list.get(0).points)
            list.add(0, record);
        else if(record.points < list.get(list.size()-1).points)
            list.add(record);
        else {
            for(int i = 1; i < list.size(); i++) {
                if(record.points > list.get(i).points) {
                    list.add(i, record);
                    
                    break;
                }
            }
        }
    }

    private int getPositionInRanking(Position record) { // Pega a posição de um nome no ranking, negativo se não existe
        for(int i = 0; i < list.size(); i++)
            if(list.get(i).name.equals(record.name))
                return i;

        return -1;
    }

    public void loadRanking(String url) { // Carrega o ranking a partir de um arquivo
        try {
            FileReader file = new FileReader(url);
            Scanner reader = new Scanner(file);

            for(int i = reader.nextInt(); i > 0; i--)
                this.Add(new Position(reader.next(), reader.nextInt()));

            reader.close();
            file.close();
        } catch (FileNotFoundException ex) {
            try {
                FileWriter file = new FileWriter(url);

                file.write("" + 0);

                file.close();
            } catch (IOException ex1) {
                Logger.getLogger(RankHandle.class.getName()).log(Level.SEVERE, null, ex1);
            }
        } catch (IOException ex) {
            Logger.getLogger(RankHandle.class.getName()).log(Level.SEVERE, null, ex);
        }

    }

    public void saveRanking(String url) { // Salva o ranking num arquivo
        try {
            FileWriter file = new FileWriter(url);

            file.write("" + list.size());

            for(int i = 0; i < list.size(); i++)
                file.write("\n" + list.get(i).name + " " + list.get(i).points);

            file.close();
        } catch (IOException ex) {
            Logger.getLogger(RankHandle.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public Position getRecord(int index) {
        if(index < list.size())
            return list.get(index);

        return null;
    }

    public int Size() {
        return list.size();
    }
}
