package ranking;

import JPlay.*;
import java.util.ArrayList;
import java.awt.Color;
import java.awt.Font;

public class RankList {
    private Window              app;
    private ArrayList<Position> list;
    private int                 spacing, // Espaço entre um elemento e outro da lista
                                pointsdistance, //
                                height, // Quantidade de linhas que será mostrada
                                pos, // Posição na lista
                                x, y;
    private Font                font;
    private Color               color, // Cor da fonte
                                rect1, rect2; // Cor intercalada da lista

    public RankList(Window app) {
        this(app, 20, 10, 300);
    }

    public RankList(Window app, int spacing, int height, int pointsdistance) {
        this.app = app;
        this.spacing = spacing;
        this.height = height;
        this.pointsdistance = pointsdistance;
        this.pos = this.x = this.y = 0;

        this.list = new ArrayList<Position>();

        this.color = Color.WHITE;
        this.font = new Font("Arial", Font.TRUETYPE_FONT, 14);

        this.rect1 = Color.BLUE;
        this.rect2 = new Color(100, 150, 255);
    }

    public void Add(Position element) { // Adiciona um elemento ao final da lista
        list.add(element);
    }

    public void Remove(int index) { // Remove um elemento na posição index
        if(index < list.size())
            list.remove(index);
    }

    public void moveDown() { // Move a lista para baixo
        if(pos + height < list.size())
            pos++;
    }

    public void moveUp() { // Move a lista para cima
        if(pos > 0)
            pos--;
    }

    public void Draw() {
        for(int i = pos; (i - pos) < height && i < list.size(); i++) {
            if(i % 2 == 0)
                app.drawRect(x - 5, y + (i - pos)*spacing, pointsdistance + 50, 20, rect1);
            else
                app.drawRect(x - 5, y + (i - pos)*spacing, pointsdistance + 50, 20, rect2);

            app.drawText(list.get(i).name, x, y + (i - pos)*spacing + 15, color, font);
            app.drawText("" + list.get(i).points, x + pointsdistance, y + (i - pos)*spacing + 15, color, font);
        }
    }

    public void setPosition(int x, int y) { // Posiciona a lista
        this.x = x;
        this.y = y;
    }

    public void setSpacing(int spacing) {
        this.spacing = spacing;
    }

    public void setHeight(int height) {
        this.height = height;
    }

    public void setPointsDistance(int pointsdistance) {
        this.pointsdistance = pointsdistance;
    }

    public void setFont(Font font) {
        this.font = font;
    }

    public void setFontColor(Color color) {
        this.color = color;
    }

    public void setBackgroundColors(Color rect1, Color rect2) {
        this.rect1 = rect1;
        this.rect2 = rect2;
    }
}
