package shop;

import JPlay.*;
import gameplay.Player;
import java.awt.Color;
import java.awt.Font;
import menupack.Button;
import gameplay.hud.Panel;

public class Shop {
    private Window app;
    private Keyboard input;
    private Mouse mouse;
    private GameImage background, featuresPanel;
    private int fx, fy; // x e y das informações da nave
    private double c50, c100, c200, agil, vel, fr, bd, bv, ts; // Preços dos itens
    private Font font;
    private Panel moneypane, cascopane;

    private Button casco50, casco100, casco200, agility, veloc, firerate, bulletdamage, bulletveloc, trippleshot;

    public Shop(Window app, String bgimg) {
        this.app = app;

        input = app.getKeyboard();
        mouse = app.getMouse();

        background = new GameImage(bgimg);
        featuresPanel = new GameImage("data/shop/featurespanel.png");

        fx = 50;
        fy = 150;

        featuresPanel.x = fx - 10;
        featuresPanel.y = fy - 90;

        font = new Font("Lucida Console", Font.TRUETYPE_FONT, 15);

        casco50 = new Button("data/shop/casco50button.png", fx - 10, fy + 180, mouse);
        casco100 = new Button("data/shop/casco100button.png", fx - 10, fy + 260, mouse);
        casco200 = new Button("data/shop/casco200button.png", fx - 10, fy + 340, mouse);
        agility = new Button("data/shop/agilitybutton.png", fx + 150, fy + 180, mouse);
        veloc = new Button("data/shop/velocitybutton.png", fx + 150, fy + 260, mouse);
        firerate = new Button("data/shop/fireratebutton.png", fx + 150, fy + 340, mouse);
        bulletdamage = new Button("data/shop/damagebutton.png", fx + 310, fy + 180, mouse);
        bulletveloc = new Button("data/shop/bulletveloc.png", fx + 310, fy + 260, mouse);
        trippleshot = new Button("data/shop/trippleshot.png", fx + 310, fy + 340, mouse);

        moneypane = new Panel(app, "data/gameplay/moneypanel.png", app.getWidth() - 110, app.getHeight() - 60);
        cascopane = new Panel(app, "data/gameplay/cascopanel.png", app.getWidth() - 220, app.getHeight() - 60);

        c50 = 1000.0;
        c100 = 1900.0;
        c200 = 3700.0;
        agil = vel = fr = bd = bv = 100.0;
        ts = 120000;
    }

    public void Open(Player player) {
        while(!mouse.isRightButtonPressed() && !input.keyDown(Keyboard.ESCAPE_KEY)) {
            Draw(player);

            if(mouse.isLeftButtonPressed()) {
                if(casco50.isMouseOn()) {
                    if(player.money > c50) {
                        player.money -= c50;
                        player.casco += 50;
                    }
                }
                if(casco100.isMouseOn()) {
                    if(player.money > c100) {
                        player.money -= c100;
                        player.casco += 100;
                    }
                }
                if(casco200.isMouseOn()) {
                    if(player.money > c200) {
                        player.money -= c200;
                        player.casco += 200;
                    }
                }
                if(agility.isMouseOn()) {
                    if(player.money > agil) {
                        player.money -= agil;
                        player.agility += 100.0;
                        agil *= 2.0;
                    }
                }
                if(veloc.isMouseOn()) {
                    if(player.money > vel) {
                        player.money -= vel;
                        player.maxspeed += 100;
                        vel *= 2.0;
                    }
                }
                if(firerate.isMouseOn()) {
                    if(player.money > fr) {
                        player.money -= fr;
                        player.firerate = 1000.0/(1000.0/player.firerate + 1.0);
                        fr *= 2.0;
                    }
                }
                if(bulletdamage.isMouseOn()) {
                    if(player.money > bd) {
                        player.money -= bd;
                        player.bulletdamage += 5.0;
                        bd *= 2.0;
                    }
                }
                if(bulletveloc.isMouseOn()) {
                    if(player.money > bv) {
                        player.money -= bv;
                        player.bulletveloc += 50.0;
                        bv *= 2.0;
                    }
                }
                if(trippleshot.isMouseOn()) {
                    if(player.money > ts) {
                        player.money -= ts;
                        player.guntype = player.guntype.trippleshot;
                        ts = 999999;
                    }
                }
            }
        }
    }

    private void Draw(Player player) {
        showFeatures(player);
    }

    private void showFeatures(Player player) {
        featuresPanel.draw();

        app.drawText("Casco......" + (int)player.casco, fx, fy, Color.GREEN, font);
        app.drawText("Dinheiro...P$: " + (int)player.money, fx, fy + 20, Color.GREEN, font);
        app.drawText("Agilidade.............." + (int)player.agility, fx, fy + 60, Color.GREEN, font);
        app.drawText("Velocidade............." + (int)player.maxspeed, fx, fy + 80, Color.GREEN, font);
        app.drawText("Tiros por segundo......" + (int)(1000.0/player.firerate), fx, fy + 100, Color.GREEN, font);
        app.drawText("Danos do tiro.........." + (int)player.bulletdamage, fx, fy + 120, Color.GREEN, font);
        app.drawText("Velocidade dos tiros..." + (int)player.bulletveloc, fx, fy + 140, Color.GREEN, font);

        moneypane.setText("P$: " + (int)player.money);
        cascopane.setText("" + (int)player.casco);

        casco50.draw();
        casco100.draw();
        casco200.draw();
        agility.draw();
        veloc.draw();
        firerate.draw();
        bulletdamage.draw();
        bulletveloc.draw();
        trippleshot.draw();

        cascopane.Draw();
        moneypane.Draw();

        app.drawText("P$: 1000", fx + 15, fy + 235, Color.GREEN, font);
        app.drawText("P$: 1900", fx + 15, fy + 315, Color.GREEN, font);
        app.drawText("P$: 3700", fx + 15, fy + 395, Color.GREEN, font);
        app.drawText("P$: " + (int)agil, fx + 175, fy + 235, Color.GREEN, font);
        app.drawText("P$: " + (int)vel, fx + 175, fy + 315, Color.GREEN, font);
        app.drawText("P$: " + (int)fr, fx + 175, fy + 395, Color.GREEN, font);
        app.drawText("P$: " + (int)bd, fx + 335, fy + 235, Color.GREEN, font);
        app.drawText("P$: " + (int)bv, fx + 335, fy + 315, Color.GREEN, font);
        app.drawText("P$: " + (int)ts, fx + 335, fy + 395, Color.GREEN, font);

        app.display();
    }
}
